#Noesis python importer - EA FIFA 06 head model .rx2 files - version 1.2
from inc_noesis import *
import noesis
#rapi methods should only be used during handler callbacks
import rapi
#registerNoesisTypes is called by Noesis to allow the script to register formats.
#Do not implement this function in script files unless you want them to be dedicated format modules!
def registerNoesisTypes():
	handle = noesis.register("FIFA 06 models (X360)", ".rx2")
	noesis.setHandlerTypeCheck(handle, noepyCheckType)
	noesis.setHandlerLoadModel(handle, noepyLoadModel)
	noesis.logPopup()
	#print("The log can be useful for catching debug prints from preview loads.\nBut don't leave it on when you release your script, or it will probably annoy people.")
	return 1
#check if it's this type based on the data
def noepyCheckType(data):
    bs = NoeBitStream(data)
    Magic = bs.readBytes(7)
    if Magic != b'\x89\x52\x57\x34\x78\x62\x32':
        return 0
    return 1  

#load the model
def noepyLoadModel(data, mdlList):
   VInfo = []
   VOff = []
   VBufferSize = []
   FInfo = []   
   FOff = []
   FBufferSize = []
   MeshInfo = []
   DescID = []
   VBsize = []
   UVpos = []
   UVtype = []
   UV2pos = []
   UV2type = []
   UV3pos = []
   UV3type = []
   UV4pos = []
   UV4type = []
   UV5pos = []
   UV5type = []
   COLpos = []
   COLtype = []
   BIpos = []
   BItype = []
   BWpos = []
   BWtype = []
   VBsize = []
   VertType = []
   ctx = rapi.rpgCreateContext()
   bs = NoeBitStream(data, NOE_BIGENDIAN)
   bs.seek(0x20, NOESEEK_ABS)
   fileCount = bs.read(">i")
   bs.seek(12, NOESEEK_REL)
   fileTable = bs.read(">i")
   bs.seek(fileTable[0], NOESEEK_ABS)
   meshCount = 0
   descriptorCount = 0
   j = 0
   
   for i in range(0, fileCount[0]):
	    fileInfo = bs.read(">iiiii")
	    fileType = fileInfo[4]
	   			    
	    if fileType != 1:
	   		MeshInfo.append(i)
	    
	    if fileType == 2:
	   		VInfo.append([fileInfo[0]])
	   		meshCount +=1
	    
	    elif fileType == 3:
	   		FInfo.append([fileInfo[0]])   		
	   			    
	    elif fileType == 1:
	   		MeshInfo.append([fileInfo[0]])
	   		descriptorCount +=1
	   		DescID.append([i])
	   		print(i)   	
	   				 			   		
	    
	    elif fileType == 0:
	   		j += 1
	   		if j < meshCount + 1:
	   			VOff.append([fileInfo[0]])
	   			VBufferSize.append([fileInfo[2]])

	   		else:
	   			FOff.append([fileInfo[0]])
	   			FBufferSize.append([fileInfo[2]])	 			   		

   UVCount = 0
   UV2Count = 0
   UV3Count = 0
   UV4Count = 0
   UV5Count = 0
   COLCount = 0
   BICount = 0
   BWCount = 0

   for i in range(0, meshCount):
   		bs.seek(VInfo[i][0] + 28, NOESEEK_ABS)
   		partID = bs.read(">i")
   		bs.seek(MeshInfo[partID[0]][0], NOESEEK_ABS)
   		info = bs.read(">iBBBBBBBB")
   		VBsize.append(info[5])
   		for j in range(0, info[2]):
   			position = bs.read(">i")
   			type = bs.readBytes(8)
   			if type == b'\x00\x2A\x23\xB9\x00\x00\x00\x01':
   				VertType.append(1)   			
   			elif type == b'\x00\x1A\x23\x60\x00\x00\x00\x01':
   				VertType.append(2)  			
   			elif type == b'\x00\x1A\x23\xA6\x00\x00\x00\x01':
   				VertType.append(3)
   			elif type == b'\x00\x2C\x23\xA5\x00\x05\x00\x06':
   				UVpos.append(position[0])
   				UVtype.append(1)
   				UVCount += 1
   			elif type == b'\x00\x2C\x23\xA5\x00\x05\x01\x07':
   				UV2pos.append(position[0])
   				UV2type.append(1)
   				UV2Count += 1
   			
   			elif type == b'\x00\x2C\x23\xA5\x00\x05\x02\x08':
   				UV3pos.append(position[0])
   				UV3type.append(1)
   				UV3Count += 1
   			
   			elif type == b'\x00\x2C\x23\xA5\x00\x05\x03\x09':
   				UV4pos.append(position[0])
   				UV4type.append(1)
   				UV4Count += 1
   			
   			elif type == b'\x00\x2C\x23\xA5\x00\x05\x04\x0A':
   				UV5pos.append(position[0])
   				UV5type.append(1)
   				UV5Count += 1
   			
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x01\x07':
   				UV2pos.append(position[0])
   				UV2type.append(2)
   				UV2Count += 1
   			
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x02\x08':
   				UV3pos.append(position[0])
   				UV3type.append(2)
   				UV3Count += 1
   			
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x03\x09':
   				UV4pos.append(position[0])
   				UV4type.append(2)
   				UV4Count += 1	
   			
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x04\x0A':
   				UV5pos.append(position[0])
   				UV5type.append(2)
   				UV5Count += 1	
   			
   			elif type == b'\x00\x2C\x23\x5F\x00\x05\x00\x06':
   				UVpos.append(position[0])
   				UVtype.append(2)
   				UVCount += 1
   			
   			elif type == b'\x00\x2C\x20\x59\x00\x05\x00\x06':
   				UVpos.append(position[0])
   				UVtype.append(3)
   				UVCount += 1   			

   			elif type == b'\x00\x2C\x21\x59\x00\x05\x00\x06':
   				UVpos.append(position[0])
   				UVtype.append(4)
   				UVCount += 1
   				
   			elif type == b'\x00\x18\x28\x86\x00\x0A\x00\x04':
   				COLpos.append(position[0])
   				COLtype.append(1)
   				COLCount += 1
   			elif type == b'\x00\x1A\x22\x5A\x00\x02\x00\x0E':
   				BIpos.append(position[0])
   				BItype.append(1)
   				BICount += 1

   			elif type == b'\x00\x1A\x20\x86\x00\x01\x00\x0F':
   				BWpos.append(position[0])
   				BWtype.append(1)
   				BWCount += 1
   				 			
   		if UVCount == i:
   			UVtype.append(0)
   			UVpos.append(0)
   			UVCount += 1
   		
   		if UV2Count == i:
   			UV2type.append(0)
   			UV2pos.append(0)
   			UV2Count += 1
   		
   		if UV3Count == i:
   			UV3type.append(0)
   			UV3pos.append(8)
   			UV3Count += 1
   		
   		if UV4Count == i:
   			UV4type.append(0)
   			UV4pos.append(0)
   			UV4Count += 1
   		
   		if UV5Count == i:
   			UV5type.append(0)
   			UV5pos.append(0)
   			UV5Count += 1
   		
   		if COLCount == i:
   			COLtype.append(0)
   			COLpos.append(8)
   			COLCount += 1
   		
   		if BICount == i:
   			BItype.append(0)
   			BIpos.append(8)
   			BICount += 1
   		
   		if BWCount == i:
   			BWtype.append(0)
   			BWpos.append(8)
   			BWCount += 1   
   
   
   for i in range(0, meshCount):
   			
   		rapi.rpgClearBufferBinds()
   		B = 0
   		bs.seek(VInfo[i][0] + 20, NOESEEK_ABS) #Seek to vertices info
   		VData = bs.read(">HHi")
   		VBsize = VData[0]
   		VCount = VData[2]
   		bs.seek(FOff[i][0], NOESEEK_ABS)

   		bs.seek(FInfo[i][0], NOESEEK_ABS) #Seek to faces info
   		bs.seek(20, NOESEEK_REL)
   		FCount = bs.read(">HH")
   		#sometimes triangle count isn't divisible by 3. Subtract B from triangle count
   		if FCount [1] % 3 != 0:
   			B += 2  
   		bs.seek(VOff[i][0], NOESEEK_ABS) #Seek to Vertices Start
   		VertBuff = bs.readBytes(VBufferSize[i][0])
   		rapi.rpgSetName("mesh_" + str(i))
   		rapi.rpgSetOption(noesis.RPGOPT_BIGENDIAN, 1)
   		if VertType[i] == 1:
   			rapi.rpgBindPositionBufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, 0)
   		
   		elif VertType[i] == 2:
   			rapi.rpgBindPositionBufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, 0)   		
   		
   		elif VertType[i] == 3:
   			rapi.rpgBindPositionBufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, 0)
   		
   		if UVtype[i] == 1:
   			rapi.rpgBindUV1BufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, UVpos[i])
   		
   		elif UVtype[i] == 2:
   			rapi.rpgBindUV1BufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, UVpos[i])
   		
   		elif UVtype[i] == 3:
   			rapi.rpgBindUV1BufferOfs(VertBuff, noesis.RPGEODATA_USHORT, VBsize, UVpos[i])   			 			
   		
   		elif UVtype[i] == 4:
   			rapi.rpgBindUV1BufferOfs(VertBuff, noesis.RPGEODATA_SHORT, VBsize, UVpos[i])
   		
   		if UV2type[i] == 1:
   			rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, UV2pos[i])
   			
   		elif UV2type[i] == 2:
   			rapi.rpgBindUV2BufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, UV2pos[i])
   		
   		
   		if UV3type[i] == 1:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, 3, 3, UV3pos[i])
   		
   		elif UV3type[i] == 2:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, 3, 3, UV3pos[i])
   		
   		elif UV3type[i] == 3:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_USHORT, VBsize, 3, 3, UV3pos[i])   			 			
   		
   		elif UV3type[i] == 4:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_SHORT, VBsize, 3, 3, UV3pos[i])
   		
   		if UV4type[i] == 1:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, 4, 4, UV4pos[i])
   		
   		elif UV4type[i] == 2:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, 4, 4, UV4pos[i])
   		
   		elif UV4type[i] == 3:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_USHORT, VBsize, 4, 4, UV4pos[i])   			 			
   		
   		elif UV4type[i] == 4:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_SHORT, VBsize, 4, 4, UV4pos[i])
   		
   		if UV5type[i] == 1:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_FLOAT, VBsize, 5, 5, UV5pos[i])
   		
   		elif UV5type[i] == 2:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_HALFFLOAT, VBsize, 5, 5, UV5pos[i])
   		
   		elif UV5type[i] == 3:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_USHORT, VBsize, 5, 5, UV5pos[i])   			 			
   		
   		elif UV5type[i] == 4:
   			rapi.rpgBindUVXBufferOfs(VertBuff, noesis.RPGEODATA_SHORT, VBsize, 5, 5, UV5pos[i])
   		
   		if COLtype[i] == 1:
   			rapi.rpgBindColorBufferOfs(VertBuff, noesis.RPGEODATA_UBYTE, VBsize, COLpos[i], 4)
   		
   		if BItype[i] == 1:
   			rapi.rpgBindBoneIndexBufferOfs(VertBuff, noesis.RPGEODATA_USHORT, VBsize, BIpos[i], 2)
   		if BWtype[i] == 1:
   			rapi.rpgBindBoneWeightBufferOfs(VertBuff, noesis.RPGEODATA_UBYTE, VBsize, BWpos[i], 4)
   			   			  				
   		bs.seek(FOff[i][0], NOESEEK_ABS) #Seek to Faces Start
   		FaceBuff = bs.readBytes(FBufferSize[i][0])
   		rapi.rpgCommitTriangles(FaceBuff, noesis.RPGEODATA_USHORT, FCount[1] - B, noesis.RPGEO_TRIANGLE_STRIP, 1)
   	
   	  
   mdl = rapi.rpgConstructModel()
   mdlList.append(mdl)         #important, don't forget to put your loaded model in the mdlList
   rapi.rpgClearBufferBinds()
   rapi.rpgReset() 
   return 1